<?php
/**
  * Copyright (c) 2006-2018 Massachusetts General Hospital
  * All rights reserved. This program and the accompanying materials
  * are made available under the terms of the i2b2 Software License v2.1
  * which accompanies this distribution.
  *
  * register.php
  * gets posted data from the Registration form and calls PM Services to add User to i2b2
  * @category ACT
  * @package  Registration 
  * @author   Nich and Jay
  * @version  May 2018
  */

require_once('i2b2.php');
require_once('config.php');

date_default_timezone_set('America/New_York');


$project_id = $config_start_project_id;


$user_name = $_POST["user_name"];
$email = $_POST["email"];
$full_name = $_POST["full_name"];

$is_registered = user_has_role("USER",i2b2_get_role($user_name,$config_start_project_id));

if($is_registered)  //redirect user to SHRINE log in page
{
	header($config_SHRINE_URL); 
	exit;
}


$result_status_error = result_status_error(i2b2_set_user($user_name, $full_name, $email, "", ""));


if(!$result_status_error){	
	$result_status_error_role1 = result_status_error(i2b2_set_role($user_name, 'DATA_AGG', $project_id));
	$result_status_error_role2 = result_status_error(i2b2_set_role($user_name, 'USER', $project_id));
		
	if(!$result_status_error_role1 && !$result_status_error_role2){
		i2b2_set_user_param($user_name, "authentication_method", "T", "NTLM");
		i2b2_set_user_param($user_name, "domain", "T", $config_AD_Domain);
		i2b2_set_user_param($user_name, "domain_controller", "T", $config_domain_controler);		
		
		//Here is where an email can be sent welcoming the user to SHRINE ACT.  
		//And another email to alert the site admin that a new user was added.
			
		header($config_SHRINE_URL); 
	    exit;
		}
		else {
			echo "Error setting user info";
			//add some way of alerting site admin of failed attempt to add user
		}
	}
	else {
		echo "Error setting User";
		//add some way of alerting site admin of failed attempt to add user
	}

?>
